package id.go.kemenag.madrasah.pmrms.auth.contoller

import id.go.kemenag.madrasah.pmrms.auth.model.request.auth.LoginRequest
import id.go.kemenag.madrasah.pmrms.auth.model.response.ReturnData
import id.go.kemenag.madrasah.pmrms.auth.service.AuthService
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.ResponseEntity
import org.springframework.web.bind.annotation.*
import javax.validation.Valid

@RestController
@RequestMapping(path = ["auth"])
class AuthController {

    @Autowired
    private lateinit var service: AuthService

    @PostMapping(value = ["login"], produces = ["application/json"])
    fun login(@Valid @RequestBody request: LoginRequest): ResponseEntity<ReturnData> {
        return service.login(request)
    }

    @GetMapping(value = ["detail"], produces = ["application/json"])
    fun detail(): ResponseEntity<ReturnData> {
        return service.detail()
    }
}
